{
CTU FEE Local Contest
Solution author: Martin Kacer
(30min)
}

Program Jugs;

Const MAX = 1024;
	COMB = MAX * MAX;

Type TMove = (FILL_A, FILL_B, EMPTY_A, EMPTY_B, POUR_AB, POUR_BA);
Const Names : Array [TMove] of String(20) =
	('fill A', 'fill B', 'empty A', 'empty B', 'pour A B', 'pour B A');

Var Queue, Prev: Array [0..COMB] of Integer;
	LastMov: Array [0..COMB] of TMove;
	QB, QE: Integer;
	Vis: Array [0..COMB] of Boolean;
	CapA, CapB, Goal: Integer;
	FoundFinal: Integer;


Function CntStates : Integer;
Begin CntStates := (CapA+1) * (CapB+1); End;

Function GetState (A, B: Integer) : Integer;
Begin GetState := A * (CapB+1) + B; End;

Function StateA (X: Integer) : Integer;
Begin StateA := X div (CapB+1); End;

Function StateB (X: Integer) : Integer;
Begin StateB := X mod (CapB+1); End;

Function FinalState (A, B: Integer) : Boolean;
Begin FinalState := (A = Goal) or (B = Goal); End;
{Begin FinalState := (B = Goal); End;}


Procedure Enqueue (A, B, P: Integer; M: TMove);
Var S: Integer;
Begin
	S := GetState (A, B);
	If not Vis[S] then
	Begin
		Vis[S] := true;  Prev[S] := P;  LastMov[S] := M;
		Queue[QE] := S;  Inc(QE);
		If FinalState (A, B) then FoundFinal := S;
	End;
End; { Enqueue }


Procedure Expand (S: Integer);
Var A, B: Integer;
Begin
	A := StateA (S);  B := StateB (S);
	Enqueue (CapA, B, S, FILL_A);
	Enqueue (A, CapB, S, FILL_B);
	Enqueue (0, B, S, EMPTY_A);
	Enqueue (A, 0, S, EMPTY_B);
	If (A + B <= CapB) then
		Enqueue (0, A+B, S, POUR_AB)
	else
		Enqueue (A+B-CapB, CapB, S, POUR_AB);
	If (A + B <= CapA) then
		Enqueue (A+B, 0, S, POUR_BA)
	else
		Enqueue (CapA, A+B-CapA, S, POUR_BA);
End; { Expand }


Procedure PrintPath (S: Integer);
Begin
	If (Prev[S] >= 0) then
	Begin
		PrintPath (Prev[S]);
		WriteLn (Names[LastMov[S]]);
	End;
End; { PrintPath }


Var I, S: Integer;

Begin
	While not Eof do
	Begin
		ReadLn (CapA, CapB, Goal);
		QB := 1;  QE := 1;
		For I := 0 to CntStates do Vis[I] := false;
		FoundFinal := -1;
		Enqueue (0, 0, -1, EMPTY_A {unused});
		While (FoundFinal < 0) and (QB < QE) do
		Begin
			S := Queue[QB];  Inc(QB);
			Expand (S);
		End;
		PrintPath (FoundFinal);
		WriteLn ('success'); WriteLn;
	End;
End.

