{
CTU FEE Local Contest
Solution author: Martin Kacer
(45 min analyzing: 35+10)
(35 min coding)
}

Program Pipe;

Const MAX = 32;
	EPS = 1E-8;

Var X, Y : Array [1..MAX] of Real;
	Count : Integer;


{ find the cross point of two lines: (X1,Y1)(X2,Y2) and (X3,Y3)(X4,Y4)
1) it always does exist;
2) the lines are never parallel;
3) X1<X2 and X3<X4;
return the x-coordinate only}
Function CrossPoint (X1,Y1,X2,Y2, X3,Y3,X4,Y4 : Real) : Real;
Var S21, S43 : Real;
Begin
	S21 := (Y2-Y1) / (X2-X1);
	S43 := (Y4-Y3) / (X4-X3);
	CrossPoint := (Y3 - Y1 + X1 * S21 - X3 * S43) / (S21 - S43);
End; { CrossPoint }


{ how far can this particular line go ?  there is always X1 < X2 ! }
Function MaxForLine (X1, Y1, X2, Y2 : Real) : Real;
Var I : Integer;
Begin
	I := 1;
	While (I <= Count)
			and ((X2-X1) * (Y[I]-Y1) + EPS > (Y2-Y1) * (X[I]-X1))
			and ((X2-X1) * (Y[I]-1-Y1) < EPS + (Y2-Y1) * (X[I]-X1)) do
		Inc(I);
	If (I = 1) then
		MaxForLine := X[1]
	else If (I > Count) then
		MaxForLine := X[Count]
	else Begin
		If ((X2-X1) * (Y[I]-Y1) + EPS > (Y2-Y1) * (X[I]-X1)) then
			MaxForLine := CrossPoint (X1, Y1, X2, Y2,
									  X[I-1], Y[I-1]-1, X[I], Y[I]-1)
		else
			MaxForLine := CrossPoint (X1, Y1, X2, Y2,
									  X[I-1], Y[I-1], X[I], Y[I]);
	End;
End; { MaxForLine }


{ test all possible lines }
Function Solve : Real;
Var ActX, BestX : Real;
	I, J : Integer;
Begin
	BestX := X[1];
	For I := 1 to Count-1 do
		For J := I+1 to Count do
		Begin
			ActX := MaxForLine (X[I], Y[I], X[J], Y[J]-1);
			If (ActX > BestX) then BestX := ActX;
			ActX := MaxForLine (X[I], Y[I]-1, X[J], Y[J]);
			If (ActX > BestX) then BestX := ActX;
		End;
	Solve := BestX;
End; { Solve }


Var I : Integer;
	MaxX : Real;

Begin
	ReadLn (Count);
	While (Count > 0) do
	Begin
		For I := 1 to Count do ReadLn (X[I], Y[I]);
		MaxX := Solve;
		If (MaxX >= X[Count] - EPS) then
			WriteLn ('Through all the pipe.')
		else
			WriteLn (MaxX : 1 : 2);
		ReadLn (Count);
	End;
End.

