{
CTU FEE Local Contest
Solution author: Martin Kacer
(30min - coding)
(20min - problem with Pascal strings)
(30min - error with 3-letter columns)
(10min - other Pascal related problem)
}

Program Sheet;

Const MaxR = 1024;
	MaxC = 1024;
	MaxMem = 1024 * 1024;

Type
	TExpr = Record R, C: Integer; End;
	TCell = Record Val: Integer; ExpB, ExpE: Integer; End;

Var Memory : Array [1..MaxMem] of TExpr;
	MemLast : Integer;
	SprSheet : Array [1..MaxR, 1..MaxC] of TCell;
	Row : String(1000000);
	SizeC, SizeR : Integer;


Function ScanNum (Var I: Integer) : Integer;
Var Res : Integer;
Begin
	Res := 0;
	While (I <= Length(Row)) and (Row[I] in ['0'..'9']) do
	Begin
		Res := Res * 10 + Ord(Row[I]) - Ord('0');
		Inc(I);
	End;
	ScanNum := Res;
End; { ScanNum }

Function ScanCol (Var I: Integer) : Integer;
Var N: Array[1..3] of Integer;
	C: Integer;
	Res: Integer;
Begin
	C := 0;
	Res := 0;
	While (I <= Length(Row)) and (Row[I] in ['A'..'Z']) do
	Begin
		Inc(C);
		N[C] := Ord(Row[I]) - Ord('A');
		Res := Res * 26 + N[C];
		Inc(I);
	End;
	If (C = 3) then ScanCol := Res + 26 * 26 + 26 + 1
	else If (C = 2) then ScanCol := Res + 26 + 1
	else ScanCol := Res + 1;
End; { ScanCol }



Procedure ReadSheet;
Var R, C : Integer;
	I : Integer;
Begin
	ReadLn (SizeC, SizeR);
	MemLast := 0;
	For R := 1 to SizeR do
	Begin
		ReadLn (Row);
		I := 1;
		For C := 1 to SizeC do
		Begin
			While (Row[I] = ' ') do Inc(I);
			If (Row[I] = '=') then
			Begin
				SprSheet[R,C].ExpB := MemLast + 1;
				While (Row[I] in ['=','+']) do
				Begin
					Inc(I);
					Inc(MemLast);
					Memory[MemLast].C := ScanCol (I);
					Memory[MemLast].R := ScanNum (I);
				End;
				SprSheet[R,C].ExpE := MemLast;
			End else Begin
				SprSheet[R,C].ExpB := 0;
				SprSheet[R,C].Val := ScanNum (I);
			End;
		End;
	End;
End; { ReadSheet }


Function ComputeSheet : Boolean;
Var I, J, K : Integer;
	Ok : Boolean;
Begin
	ComputeSheet := true;
	For I := 1 to SizeR do
		For J := 1 to SizeC do
			If (SprSheet[I,J].ExpB > 0) then
			Begin
				Ok := true;
				SprSheet[I,J].Val := 0;
				For K := SprSheet[I,J].ExpB to SprSheet[I,J].ExpE do
					With Memory[K] do
						If (SprSheet[R,C].ExpB = 0) then
							Inc (SprSheet[I,J].Val, SprSheet[R,C].Val)
						else
							Ok := false;
				If Ok then
					SprSheet[I,J].ExpB := 0
				else
					ComputeSheet := false;
			End;
End; { ComputeSheet }


Procedure PrintSheet;
Var I, J : Integer;
Begin
	For I := 1 to SizeR do
	Begin
		For J := 1 to SizeC do
		Begin
			If (J > 1) then Write (' ');
			Write (SprSheet[I,J].Val);
		End;
		WriteLn;
	End;
End;


Var NrTask, Task : Integer;

Begin
	ReadLn (NrTask);
	For Task := 1 to NrTask do
	Begin
		ReadSheet;
		While not ComputeSheet do Begin End;
		PrintSheet;
		WriteLn;
	End;
End.

